package form.run;

import form.io.*;

public class ReceiverMailer {

	/**
	* the name of the local host, used when connecting to
	* the mail server
	*/
	static final String localHost = "pse.cs.vt.edu";

	/**
	* the port of the smtp Should always be 25
	*/
	static final int mailPort = 25;

	/**
	* this is the suffix for the mail tempelate files
	*/
	static final String readme = "README";

	/**
	* The variable in the mail tempelate file
	* which is replaced with the dirctory containg 
	* the outputted data
	*/
	static final String replaceMe = "$1";

	public ReceiverMailer(String mailDir, String email,String results){
		String dataOut = ReadFiles.readFile(mailDir+readme);

		System.out.println("Directory: "+results);

		dataOut = parse(dataOut,results);

		System.out.println("Parsed: "+dataOut);

		WriteFiles.writeFile(dataOut,mailDir+readme);
		mail(email,dataOut);

		System.out.println("Should have been sent");
	}

	private String parse(String data, String dir){
		int curr =0;
		int last =0;
		String newData = "";

		curr = data.indexOf(replaceMe);
		while (curr != -1){
		   newData += data.substring(last, curr);
		   newData+=dir;
		   last = curr+replaceMe.length();
		   curr = data.indexOf(replaceMe,last);
		}
		return newData+data.substring(last);
	}

    public void mail(String email, String msg){
      MailClient c = new MailClient(localHost,mailPort);
        if(c.helo())
          System.out.println("OK - HELO");
        if(c.sendFrom("randy@pse.cs.vt.edu"))
          System.out.println("OK - sendFrom");
        if(c.sendTo(email))
          System.out.println("OK - sendTo");
        if(c.startData())
          System.out.println("OK - startData");
        if(c.data(msg))
              System.out.println("OK - data 1");
        if(c.endData())
          System.out.println("OK - endData");
        if(c.quit())
          System.out.println("OK - quit");
    }

}	
